<?php

/**
 * @file
 * Contains Drupal\itchio_field\Plugin\Field\FieldFormatter\ItchioIframeFormatter.
 */

namespace Drupal\itchio_field\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'itchio_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "itchio_formatter",
 *   module = "field_example",
 *   label = @Translation("Simple text-based formatter"),
 *   field_types = {
 *     "field_example_rgb"
 *   }
 * )
 */
class ItchioIframeFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = array();

    foreach ($items as $delta => $item) {
      $elements[$delta] = array(
        // We create a render array to produce the desired markup,
        // "<p style="color: #hexcolor">The color code ... #hexcolor</p>".
        // See theme_html_tag().
        '#type' => 'html_tag',
        '#tag' => 'iframe',
        '#attributes' => array(
          'src' => '//itch.io/embed/' . $item->value,
          'width' => 552,
          'height' => 167,
          'frameborder' => 0
        ),
        '#value' => '',
      );
    }

    return $elements;
  }

}
